"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.USAGE = exports.MONGOSH_WIKI = exports.TELEMETRY_GREETING_MESSAGE = void 0;
const i18n_1 = __importDefault(require("@mongosh/i18n"));
const clr_1 = require("./clr");
exports.TELEMETRY_GREETING_MESSAGE = `
${i18n_1.default.__('cli-repl.cli-repl.telemetry')}
${i18n_1.default.__('cli-repl.cli-repl.disableTelemetry')}${(0, clr_1.colorizeForStderr)('disableTelemetry()', 'bold')} ${i18n_1.default.__('cli-repl.cli-repl.command')}
`;
exports.MONGOSH_WIKI = `
${i18n_1.default.__('cli-repl.cli-repl.wiki.info')} ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.cli-repl.wiki.link'), 'bold')}
`;
exports.USAGE = `

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.usage'), 'bold')}

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.options'), 'mongosh:section-header')}

    -h, --help                                 ${i18n_1.default.__('cli-repl.args.help')}
    -f, --file [arg]                           ${i18n_1.default.__('cli-repl.args.file')}
        --host [arg]                           ${i18n_1.default.__('cli-repl.args.host')}
        --port [arg]                           ${i18n_1.default.__('cli-repl.args.port')}
        --build-info                           ${i18n_1.default.__('cli-repl.args.buildInfo')}
        --version                              ${i18n_1.default.__('cli-repl.args.version')}
        --quiet                                ${i18n_1.default.__('cli-repl.args.quiet')}
        --shell                                ${i18n_1.default.__('cli-repl.args.shell')}
        --nodb                                 ${i18n_1.default.__('cli-repl.args.nodb')}
        --norc                                 ${i18n_1.default.__('cli-repl.args.norc')}
        --eval [arg]                           ${i18n_1.default.__('cli-repl.args.eval')}
        --json[=canonical|relaxed]             ${i18n_1.default.__('cli-repl.args.json')}
        --retryWrites[=true|false]             ${i18n_1.default.__('cli-repl.args.retryWrites')}

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.authenticationOptions'), 'mongosh:section-header')}

    -u, --username [arg]                       ${i18n_1.default.__('cli-repl.args.username')}
    -p, --password [arg]                       ${i18n_1.default.__('cli-repl.args.password')}
        --authenticationDatabase [arg]         ${i18n_1.default.__('cli-repl.args.authenticationDatabase')}
        --authenticationMechanism [arg]        ${i18n_1.default.__('cli-repl.args.authenticationMechanism')}
        --awsIamSessionToken [arg]             ${i18n_1.default.__('cli-repl.args.awsIamSessionToken')}
        --gssapiServiceName [arg]              ${i18n_1.default.__('cli-repl.args.gssapiServiceName')}
        --sspiHostnameCanonicalization [arg]   ${i18n_1.default.__('cli-repl.args.sspiHostnameCanonicalization')}
        --sspiRealmOverride [arg]              ${i18n_1.default.__('cli-repl.args.sspiRealmOverride')}

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.tlsOptions'), 'mongosh:section-header')}

        --tls                                  ${i18n_1.default.__('cli-repl.args.tls')}
        --tlsCertificateKeyFile [arg]          ${i18n_1.default.__('cli-repl.args.tlsCertificateKeyFile')}
        --tlsCertificateKeyFilePassword [arg]  ${i18n_1.default.__('cli-repl.args.tlsCertificateKeyFilePassword')}
        --tlsCAFile [arg]                      ${i18n_1.default.__('cli-repl.args.tlsCAFile')}
        --tlsAllowInvalidHostnames             ${i18n_1.default.__('cli-repl.args.tlsAllowInvalidHostnames')}
        --tlsAllowInvalidCertificates          ${i18n_1.default.__('cli-repl.args.tlsAllowInvalidCertificates')}
        --tlsCertificateSelector [arg]         ${i18n_1.default.__('cli-repl.args.tlsCertificateSelector')}
        --tlsCRLFile [arg]                     ${i18n_1.default.__('cli-repl.args.tlsCRLFile')}
        --tlsDisabledProtocols [arg]           ${i18n_1.default.__('cli-repl.args.tlsDisabledProtocols')}
        --tlsUseSystemCA                       ${i18n_1.default.__('cli-repl.args.tlsUseSystemCA')}
        --tlsFIPSMode                          ${i18n_1.default.__('cli-repl.args.tlsFIPSMode')}

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.apiVersionOptions'), 'mongosh:section-header')}

        --apiVersion [arg]                     ${i18n_1.default.__('cli-repl.args.apiVersion')}
        --apiStrict                            ${i18n_1.default.__('cli-repl.args.apiStrict')}
        --apiDeprecationErrors                 ${i18n_1.default.__('cli-repl.args.apiDeprecationErrors')}

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.fleOptions'), 'mongosh:section-header')}

        --awsAccessKeyId [arg]                 ${i18n_1.default.__('cli-repl.args.awsAccessKeyId')}
        --awsSecretAccessKey [arg]             ${i18n_1.default.__('cli-repl.args.awsSecretAccessKey')}
        --awsSessionToken [arg]                ${i18n_1.default.__('cli-repl.args.awsSessionToken')}
        --keyVaultNamespace [arg]              ${i18n_1.default.__('cli-repl.args.keyVaultNamespace')}
        --kmsURL [arg]                         ${i18n_1.default.__('cli-repl.args.kmsURL')}

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.dbAddressOptions'), 'mongosh:section-header')}

        foo                                    ${i18n_1.default.__('cli-repl.args.dbAddress/foo')}
        192.168.0.5/foo                        ${i18n_1.default.__('cli-repl.args.dbAddress/192/foo')}
        192.168.0.5:9999/foo                   ${i18n_1.default.__('cli-repl.args.dbAddress/192/host/foo')}
        mongodb://192.168.0.5:9999/foo         ${i18n_1.default.__('cli-repl.args.dbAddress/connectionURI')}

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.fileNames'), 'mongosh:section-header')}

        ${i18n_1.default.__('cli-repl.args.filenameDescription')}

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.examples'), 'mongosh:section-header')}

        ${i18n_1.default.__('cli-repl.args.connectionExampleWithDatabase')}
        ${(0, clr_1.colorizeForStderr)('$ mongosh mongodb://192.168.0.5:9999/ships', 'mongosh:uri')}

  ${(0, clr_1.colorizeForStderr)(i18n_1.default.__('cli-repl.args.moreInformation'), 'bold')} ${(0, clr_1.colorizeForStderr)('https://docs.mongodb.com/mongodb-shell', 'mongosh:uri')}.
`
    .replace(/\n$/, '')
    .replace(/^\n/, '');
//# sourceMappingURL=constants.js.map