import { ShellApiValueClass } from './decorators';
import { asPrintable } from './enums';
import type { Document, ObjectIdType } from '@mongosh/service-provider-core';
export declare class CommandResult<T = unknown> extends ShellApiValueClass {
    value: T;
    type: string;
    constructor(type: string, value: T);
    [asPrintable](): T;
    toJSON(): T;
}
export declare class BulkWriteResult extends ShellApiValueClass {
    acknowledged: boolean;
    insertedCount: number;
    insertedIds: {
        [index: number]: ObjectIdType;
    };
    matchedCount: number;
    modifiedCount: number;
    deletedCount: number;
    upsertedCount: number;
    upsertedIds: {
        [index: number]: ObjectIdType;
    };
    constructor(acknowledged: boolean, insertedCount: number, insertedIds: {
        [index: number]: ObjectIdType;
    }, matchedCount: number, modifiedCount: number, deletedCount: number, upsertedCount: number, upsertedIds: {
        [index: number]: ObjectIdType;
    });
}
export declare class InsertManyResult extends ShellApiValueClass {
    acknowledged: boolean;
    insertedIds: {
        [key: number]: ObjectIdType;
    };
    constructor(acknowledged: boolean, insertedIds: {
        [key: number]: ObjectIdType;
    });
}
export declare class InsertOneResult extends ShellApiValueClass {
    acknowledged: boolean;
    insertedId: ObjectIdType | undefined;
    constructor(acknowledged: boolean, insertedId?: ObjectIdType);
}
export declare class UpdateResult extends ShellApiValueClass {
    acknowledged: boolean;
    insertedId: ObjectIdType | null;
    matchedCount: number;
    modifiedCount: number;
    upsertedCount: number;
    constructor(acknowledged: boolean, matchedCount: number, modifiedCount: number, upsertedCount: number, insertedId: ObjectIdType | null);
}
export declare class DeleteResult extends ShellApiValueClass {
    acknowledged: boolean;
    deletedCount: number | undefined;
    constructor(acknowledged: boolean, deletedCount: number | undefined);
}
export declare class CursorIterationResult extends ShellApiValueClass {
    cursorHasMore: boolean;
    documents: Document[];
    constructor();
}
