import type { ShellInstanceState } from '@mongosh/shell-api';
import { ShellResult, EvaluationListener } from '@mongosh/shell-api';
type EvaluationFunction = (input: string, context: object, filename: string) => Promise<any>;
import { type TimingCategory } from '@mongosh/types';
type ResultHandler<EvaluationResultType> = (value: any) => EvaluationResultType | Promise<EvaluationResultType>;
declare class ShellEvaluator<EvaluationResultType = ShellResult> {
    private instanceState;
    private resultHandler;
    private hasAppliedAsyncWriterRuntimeSupport;
    private asyncWriter;
    private markTime?;
    private exposeAsyncRewriter;
    constructor(instanceState: ShellInstanceState, resultHandler?: ResultHandler<EvaluationResultType>, markTime?: (category: TimingCategory, label: string) => void, exposeAsyncRewriter?: boolean);
    private innerEval;
    customEval(originalEval: EvaluationFunction, input: string, context: object, filename: string): Promise<EvaluationResultType>;
}
export { ShellResult, ShellEvaluator, EvaluationListener };
